/*-----------------------------------------------------------------*/
/*  jd,vd,ca                  TGV                          nov99   */
/*  def_types_tgv.h           V1.0                       29nov99   */
/*  Definition des types communs aux agents TGV                    */
/*-----------------------------------------------------------------*/

#ifndef DEF_TYPES_BASE
#define DEF_TYPES_BASE
/* Type de la bal de l'agent controle pour la vitesse cible */
typedef long TypeVit ;
typedef float Vitesse ;       /* em m.s-1 */
typedef float Acceleration ;  /* en m.s-2 */
typedef float Coef ;          /* sans unite entre 0.0 et 1.0 */

/* Type des bal des agents concernes par la variation +/-   */
/*   ou le changement de status d'une var. d'etat           */
#define VALEUR_DEFAUT_MAJ (0.05); /* Valeur a appliquer par defaut pour +/- */

#define PLUS  1
#define MOINS 2
#define EGAL  3
typedef short TypeOpe;

typedef struct maj {
	TypeOpe type; /* operation a effectuer | PLUS=+ , MOINS=-, EGAL=affectation*/
	float valeur; /* valeur a appliquer pour l'operation */
	} MiseAJour ;

/* Constantes caracterisation etat du controle */
#define MANU 1
#define AUTO 2

/* si RALENTI est defini, on utilise une horloge MS ralentie */
//#define RALENTI
/* Declaration des horloges */
#ifndef __NET
#ifdef RALENTI
clock MS=gtc2(0,1,250);      /* periode = 1.25 MilliSeconde */
#else
clock MS=gtc2(0,0,1000);      /* periode = 1 MilliSeconde */
#endif
#endif

#else
/* Deja inclue */
#endif
