/* mday=14 mom= 5 year=2008 */
/* hour=13 min=53 sec=47 */
/*
===========================================================================
  Gnse des Fichiers inter/inter.pp1
                      inter/inter.ppc
                      inter.c
  tape 1 entre inter.psy
          passage sur le prprocesseur C
          sortie inter/inter.pp1
  tape 2 entre inter/inter.pp1
          passage sur cyc
          sortie inter/inter.ppc
  tape 3 entre inter/inter.ppc
          passage sur le prprocesseur C
          sortie inter/inter.sed
  tape 4 entre inter/inter.sed
          passage sur sed
            suppression des $$
          sortie inter/inter.c
*/
#include <inter_psy.h>

/*-----------------------------------------------------------------*/
/*  jd,vd,ca                  TGV                          nov99   */
/*  inter.psy                 V1.0                       13jan00   */
/*  Gestion de l'interface avec l'operateur                        */
/*-----------------------------------------------------------------*/
#include <stdlib.h>
#include <string.h>

/***********/
/*! \file stc.h
\brief Definitions for GSL C programmation style

*/

/* note: 1 letter operators have higher priority than 2 letters one which have themselves an higher priority than 3 letters one */

/*!< bolean not operator */
/*!< bolean equal operator */
/*!< bolean not equal operator */
/*!< bolean lesser than operator */
/*!< bolean lesser or equal operator */
/*!< bolean greater than operator */
/*!< bolean greater or equal operator */
/*!< bolean AND operator */
/*!< bolean Inclusive OR operator */

typedef unsigned short U_SHORT; /*!< compact C type for unsigned short */
typedef unsigned int U_INT; /*!< compact C type for unsigned int */
typedef unsigned long U_LONG; /*!< compact C type for unsigned long */
typedef unsigned char U_CHAR; /*!< compact C type for unsigned char */
typedef signed char S_CHAR; /*!< compact C type for signed char */

typedef U_LONG TEST; /*!< for boolean values */
/*!< Boolean false */
/*!< Boolean true */







typedef struct {U_LONG lig, col, coMax, etiq;} cmdCla;
typedef struct {U_CHAR val[9 +1];} repCla;
/* passage en reception : REC|REC=REC , REC|NOP=REC , NOP|NOP=NOP */
/* REC : traite les  caracteres de la vt100 */
/* NOP : ne traite pas les caracteres entres */


typedef struct {U_CHAR sorVis[180 +1];} cmdAff;



/*-----------------------------------------------------------------*/
/*  jd,vd,ca                  TGV                          nov99   */
/*  def_types_tgv.h           V1.0                       29nov99   */
/*  Definition des types communs aux agents TGV                    */
/*-----------------------------------------------------------------*/



/* Type de la bal de l'agent controle pour la vitesse cible */
typedef long TypeVit ;
typedef float Vitesse ;       /* em m.s-1 */
typedef float Acceleration ;  /* en m.s-2 */
typedef float Coef ;          /* sans unite entre 0.0 et 1.0 */

/* Type des bal des agents concernes par la variation +/-   */
/*   ou le changement de status d'une var. d'etat           */
/* Valeur a appliquer par defaut pour +/- */




typedef short TypeOpe;

typedef struct maj {
	TypeOpe type; /* operation a effectuer | PLUS=+ , MOINS=-, EGAL=affectation*/
	float valeur; /* valeur a appliquer pour l'operation */
	} MiseAJour ;

/* Constantes caracterisation etat du controle */



/* si RALENTI est defini, on utilise une horloge MS ralentie */
//#define RALENTI
/* Declaration des horloges */




 /* clock  MS=gtc2(0,0,1000); */       /* periode = 1 MilliSeconde */









/* periode de l'interface 100 ms */

 /* clock  HA_Inter = 100 *MS; */      /* periode = 100 Millisecondes ; phy0 en relatif = 0 */
 /* clock  HS_Sim   = 100 *MS; */      /* periode = 100 ms ; phy0 en relatif = 0ms */



/*=======================================================================================*/
/*-------------------------------  AgInterface  -----------------------------------------*/
/*   Agent d'interface avec l'operateur.                                                 */
/*=======================================================================================*/

#line 139 "inter.c"
#ifdef AgInterface_psy
  unsigned long pileAgent_AgInterface_psy[TaillePileAgent_AgInterface_psy];
  unsigned long long AgInterface_presenttime_psy();
  extern IVTE indVTEx_AgInterface_psy[];
  extern IVTC indVTCo_AgInterface_psy[];
  /* agent AgInterface(starttime=1) with  HA_Inter 
  */

  /* DEB global 
     */ static char label[4][7]={ "NUL   ",
                        "FAIBLE",
                        "MOYEN ",
                        "FORT  "};
     static U_CHAR rec;
     static cmdAff affDyn= {""};
     static cmdAff affSta1=
        {"\x1b" "[1;1H""\x1b" "[2J"
         "\x1b" "[5;14H traction"    
         "\x1b" "[7;14H freinage"
         "\x1b" "[9;14H mode"
         "\x1b" "[10;14H vitesse cible"};
     static cmdAff affSta2=
        {"\x1b" "[11;14H     actuelle"
         "\x1b" "[13;14H acc       cm/s/s"
         "\x1b" "[15;14H vent        m/s"
         "\x1b" "[17;14H vent"
         "\x1b" "[21;9H commande :"
        };









     static MiseAJour Commande, ChgtStatus ;
     static long  cpt=0;
     static char flag_rafale=0;
    /* FIN global */ 
   /* consult */ 
extern Coef   Buf_AgInterface_AgSimEngine_data_psy[]  ;
 
     extern Coef   Buf_AgInterface_AgSimBrakes_data_psy[]  ;
 
     extern Vitesse   Buf_AgInterface_AgSimTrain_vit_moy_psy[]  ;
 
     extern Acceleration   Buf_AgInterface_AgSimTrain_acc_psy[]  ;
 
     extern int   Buf_AgInterface_AgSimWindBlast_status_psy[]  ;
 
     extern Vitesse   Buf_AgInterface_AgSimWind_vent_psy[]  ;
 
     extern int   Buf_AgInterface_AgControl_status_psy[]  ;
 
     extern Vitesse   Buf_AgInterface_AgControl_vit_cible_psy[]  ;
 
    /* FIN consult */
#line 67 "inter.psy"

  /* DEB mesbox  */
#line 68 "inter.psy"
typedef repCla  LocTypBox_entree_psy;/* FIN mesbox */
   /* receive */ /* FIN receive */ 

  
void AgInterface()
{ long mod_psy;
enum { start_psy,tourne_psy  } body_actif_psy=start_psy;
goto LabDeb_AgInterface_start_psy;
/* debut body start */
#line 71 "inter.psy"
LabDeb_AgInterface_start_psy:  
    {
     /* valeur de MAJ par defaut des commandes */
     Commande.valeur= (0.05);  ;

     /* affichage ecran statique */
     inter_send_1_psy( &affSta1) /* with  HA_Inter*/ ;
     inter_send_2_psy( &affSta2) /* with  HA_Inter*/ ;
     inter_send_3_psy( &rec) /* with  HA_Inter*/ ;
                  
      body_actif_psy=tourne_psy ;
      inter_advance_1_psy( );/* 200ms->pour pouvoir afficher toute l'interface */
    } /* fin body start */
#line 226 "inter.c"
LabFin_AgInterface_start_psy:
switch (body_actif_psy)
  {
      
    case tourne_psy : inter_UpBo_2_psy(); goto LabDeb_AgInterface_tourne_psy;  
  } /* fin switch */


  
/* debut body tourne */
#line 85 "inter.psy"
LabDeb_AgInterface_tourne_psy:  
    {
     /* envoi des valeurs  l'cran */
     sprintf(&affDyn.sorVis[0], 
             "\x1b" "[5;23H %4d"
             "\x1b" "[13;18H %5d"
             "\x1b" "[11;28H %4d"
             "\x1b" "[7;23H %4d"
             "\x1b" "[9;20H %s"
             "\x1b" "[10;28H %4d"
             "\x1b" "[17;20H %s"
             "\x1b" "[15;19H %6.2f",
             (int)(( Buf_AgInterface_AgSimEngine_data_psy[((  (0) )+Ind_AgInterface_AgSimEngine_data_psy)%Dim_AgInterface_AgSimEngine_data_psy]     *100.0)+0.5),
             (int)(( Buf_AgInterface_AgSimTrain_acc_psy[((  (0) )+Ind_AgInterface_AgSimTrain_acc_psy)%Dim_AgInterface_AgSimTrain_acc_psy]     *100.0)+0.5),
             (int)(( Buf_AgInterface_AgSimTrain_vit_moy_psy[((  (0) )+Ind_AgInterface_AgSimTrain_vit_moy_psy)%Dim_AgInterface_AgSimTrain_vit_moy_psy]     *3.6)+0.5),
             (int)(( Buf_AgInterface_AgSimBrakes_data_psy[((  (0) )+Ind_AgInterface_AgSimBrakes_data_psy)%Dim_AgInterface_AgSimBrakes_data_psy]     *100.0)+0.5),
              Buf_AgInterface_AgControl_status_psy[((  (0) )+Ind_AgInterface_AgControl_status_psy)%Dim_AgInterface_AgControl_status_psy]     == 2  ? "AUTO  " : "MANUEL",
             (int)(( Buf_AgInterface_AgControl_vit_cible_psy[((  (0) )+Ind_AgInterface_AgControl_vit_cible_psy)%Dim_AgInterface_AgControl_vit_cible_psy]     *3.6)+0.5),
             label[  Buf_AgInterface_AgSimWindBlast_status_psy[((  (0) )+Ind_AgInterface_AgSimWindBlast_status_psy)%Dim_AgInterface_AgSimWindBlast_status_psy]      ],
              Buf_AgInterface_AgSimWind_vent_psy[((  (0) )+Ind_AgInterface_AgSimWind_vent_psy)%Dim_AgInterface_AgSimWind_vent_psy]      );
     inter_send_4_psy( &affDyn) /* with  HA_Inter*/ ;

      inter_advance_2_psy( );

     { long maxBcl_psy=1L; for(;(1) && maxBcl_psy--;){
        /* firstof */ 
          if( inter_count_1_psy()>=1 ) { inter_when_1_psy(); { static LocTypBox_entree_psy entree; inter_extract_1_psy(&entree);
           if( strlen(entree.val)<=1 ) { inter_Upda_5_psy();
             switch(entree.val[0]){
               {  case '+' : inter_Upda_7_psy();   
                  Commande.type = 1 ;
                  flag_rafale=1;
                  break;
                  case '-' : inter_Upda_8_psy();   
                  Commande.type = 2 ;
                  flag_rafale=1;
                  break;       

                  case 'a' : inter_Upda_9_psy();   
                  {ChgtStatus.valeur=0.0; ChgtStatus.type= 'a' ; inter_send_5_psy( &ChgtStatus) /* with  HS_Sim*/;}  
                  break;
                  case 'w' : inter_Upda_10_psy();   
                  {ChgtStatus.valeur=0.0; ChgtStatus.type= 'w' ; inter_send_6_psy( &ChgtStatus) /* with  HS_Sim*/;} ;
                  break;
                  case 'x' : inter_Upda_11_psy();    
                  {ChgtStatus.valeur=0.0; ChgtStatus.type= 'x' ; inter_send_7_psy( &ChgtStatus) /* with  HS_Sim*/;} ;
                  break;
                  case 'n' : inter_Upda_12_psy();   
                  {ChgtStatus.valeur=0.0; ChgtStatus.type= 'n' ; inter_send_8_psy( &ChgtStatus) /* with  HS_Sim*/;} ;
                  break;
                  case 'b' : inter_Upda_13_psy();   
                  {ChgtStatus.valeur=0.0; ChgtStatus.type= 'b' ; inter_send_9_psy( &ChgtStatus) /* with  HS_Sim*/;} ;
                  break;

                 case 's' : inter_Upda_14_psy();   
                  /* affichage ecran statique */
                  inter_send_10_psy( &affSta1) /* with  HA_Inter*/ ;
                  inter_send_11_psy( &affSta2) /* with  HA_Inter*/ ;
                  inter_send_12_psy( &rec) /* with  HA_Inter*/ ;
                   inter_advance_3_psy( );  /* 200ms->pour pouvoir afficher toute l'interface */
                  break;
                  default  : inter_Upda_15_psy();    
                  {long vit= 0;
                   if (entree.val[0]>='0' && entree.val[0]<='9') { inter_Upda_16_psy(); vit= entree.val[0]-'0'; } else { inter_Upda_17_psy(); }
                   /* Chaine non numerique ou vitesse nulle -> pas de changement */
                   if( vit!=0 ) { inter_Upda_18_psy();
                     inter_send_13_psy( &vit) /* with  HS_Sim*/ ; } else { inter_Upda_19_psy(); }
                   break;
                  }
               }}
            } else { inter_Upda_6_psy(); 
             {long vit= 0; U_CHAR * pCar= entree.val;
             { long maxBcl_psy=3L; for(;(1) && maxBcl_psy--;++pCar){
               if (*pCar>='0' && *pCar<='9') { inter_Upda_21_psy(); vit= 10*vit+ (*pCar-'0');
                } else { inter_Upda_22_psy(); /*break*/goto sortLab_2_psy; }contLab_2_psy:if(maxBcl_psy) inter_Upda_20_psy();} inter_Upda_23_psy(); sortLab_2_psy:;}
             /* Chaine non numerique ou vitesse nulle -> pas de changement */
             if( vit!=0 ) { inter_Upda_24_psy();
               inter_send_14_psy( &vit) /* with  HS_Sim*/ ; } else { inter_Upda_25_psy(); }
             } }}} else { inter_Upda_4_psy();         
          /* other */  
           {
            /*break*/goto sortLab_1_psy;
           } }
        /* endof */  /* ; */ contLab_1_psy:if(maxBcl_psy) inter_Upda_3_psy();} inter_Upda_26_psy(); sortLab_1_psy:;}
     cpt++; cpt= (mod_psy= ( 0 )+((  cpt )-( 0 ))%((  9 )-( 0 )+1), mod_psy>=( 0 ) ? mod_psy : mod_psy+((  9 )-( 0 )+1)) ;
     if(flag_rafale==1 && cpt==0) { inter_Upda_27_psy();
       {
         inter_send_15_psy( &Commande) /* with  HS_Sim*/ ;
         flag_rafale=0;
       } } else { inter_Upda_28_psy(); }
    } /* fin body tourne */
#line 329 "inter.c"
LabFin_AgInterface_tourne_psy:
switch (body_actif_psy)
  {
    case tourne_psy : inter_UpBo_3_psy(); goto LabDeb_AgInterface_tourne_psy;  
  } /* fin switch */

} /* fin agent */
#endif
#line 176 "inter.psy"


/* FIN gnration fichier */

