/* mday=14 mom= 5 year=2008 */
/* hour=13 min=53 sec=47 */
/*
===========================================================================
  Gnse des Fichiers prog/prog.pp1
                      prog/prog.ppc
                      prog.c
  tape 1 entre prog.psy
          passage sur le prprocesseur C
          sortie prog/prog.pp1
  tape 2 entre prog/prog.pp1
          passage sur cyc
          sortie prog/prog.ppc
  tape 3 entre prog/prog.ppc
          passage sur le prprocesseur C
          sortie prog/prog.sed
  tape 4 entre prog/prog.sed
          passage sur sed
            suppression des $$
          sortie prog/prog.c
*/
#include <prog_psy.h>

/*-----------------------------------------------------------------*/
/*  jd,vd,ca                  TGV                          nov99   */
/*  prog.psy                  V1.0                       01dec99   */
/*  Simulation de l'environnement (Vent & moteur)                  */
/*  Algorithme de controle du train                                */
/*-----------------------------------------------------------------*/
#include <stdlib.h>

/***********/
/*! \file stc.h
\brief Definitions for GSL C programmation style

*/

/* note: 1 letter operators have higher priority than 2 letters one which have themselves an higher priority than 3 letters one */

/*!< bolean not operator */
/*!< bolean equal operator */
/*!< bolean not equal operator */
/*!< bolean lesser than operator */
/*!< bolean lesser or equal operator */
/*!< bolean greater than operator */
/*!< bolean greater or equal operator */
/*!< bolean AND operator */
/*!< bolean Inclusive OR operator */

typedef unsigned short U_SHORT; /*!< compact C type for unsigned short */
typedef unsigned int U_INT; /*!< compact C type for unsigned int */
typedef unsigned long U_LONG; /*!< compact C type for unsigned long */
typedef unsigned char U_CHAR; /*!< compact C type for unsigned char */
typedef signed char S_CHAR; /*!< compact C type for signed char */

typedef U_LONG TEST; /*!< for boolean values */
/*!< Boolean false */
/*!< Boolean true */



/*-----------------------------------------------------------------*/
/*  jd,vd,ca                  TGV                          nov99   */
/*  def_types_tgv.h           V1.0                       29nov99   */
/*  Definition des types communs aux agents TGV                    */
/*-----------------------------------------------------------------*/



/* Type de la bal de l'agent controle pour la vitesse cible */
typedef long TypeVit ;
typedef float Vitesse ;       /* em m.s-1 */
typedef float Acceleration ;  /* en m.s-2 */
typedef float Coef ;          /* sans unite entre 0.0 et 1.0 */

/* Type des bal des agents concernes par la variation +/-   */
/*   ou le changement de status d'une var. d'etat           */
/* Valeur a appliquer par defaut pour +/- */




typedef short TypeOpe;

typedef struct maj {
	TypeOpe type; /* operation a effectuer | PLUS=+ , MOINS=-, EGAL=affectation*/
	float valeur; /* valeur a appliquer pour l'operation */
	} MiseAJour ;

/* Constantes caracterisation etat du controle */



/* si RALENTI est defini, on utilise une horloge MS ralentie */
//#define RALENTI
/* Declaration des horloges */




 /* clock  MS=gtc2(0,0,1000); */       /* periode = 1 MilliSeconde */









 /* clock  HA_Simu     = 10*MS; */     /* periode = 10ms ; phy0 = 0ms */
 /* clock  HA_Controle = 100*MS; */    /* periode = 100ms ; phy0 = 0ms */
 /* clock  HA_Rafale   = 1000*MS; */   /* periode = 1 seconde ; phy0 = 0ms */

 /* application tgv(inittime= 1000*1000) with MS; */ 

/* fonction de ssprog.c */     
long rand_long(long a, long b);
float rand_float(float a, float b);

/* Constantes de caracterisation du type de rafales */





/*=====================================================================================*/
/*-------------------------------  AgSimTrain  -----------------------------------------*/
/*     Agent de simulation du train.                                                   */
/*=====================================================================================*/

#line 133 "prog.c"
#ifdef AgSimTrain_psy
  unsigned long pileAgent_AgSimTrain_psy[TaillePileAgent_AgSimTrain_psy];
  unsigned long long AgSimTrain_presenttime_psy();
  extern IVTE indVTEx_AgSimTrain_psy[];
  extern IVTC indVTCo_AgSimTrain_psy[];
  /* agent AgSimTrain(starttime=1) with HA_Simu
  */

  /* DEB global 
     */ static const float delta_t=0.01;                                     /* 10 millisecondes */
     static const Acceleration a0=0.05, a1=1.5, a2=1.2;                           /* en m.s-2 */
     static const Coef k0=0.0001 ;                 /* Coefficient de frottement aerodynamique */
     static Acceleration acc1, acc2;                                /* Accelerations du train */
     static Vitesse temp;
    /* FIN global */    
  /* DEB temporal 
    */
#line 41 "prog.psy"

 
 typedef Vitesse   LocTypTemp_vitesse_psy;
 extern LocTypTemp_vitesse_psy Buf_AgSimTrain_AgSimTrain_vitesse_psy[]  ;
 LocTypTemp_vitesse_psy AgSimTrain_vitesse_psy/*={0.0,}*/;  
     
 
 typedef Vitesse   LocTypTemp_vit_moy_psy;
 extern LocTypTemp_vit_moy_psy Buf_AgSimTrain_AgSimTrain_vit_moy_psy[]  ;
 LocTypTemp_vit_moy_psy AgSimTrain_vit_moy_psy;
     
 
 typedef Acceleration   LocTypTemp_acc_psy;
 extern LocTypTemp_acc_psy Buf_AgSimTrain_AgSimTrain_acc_psy[]  ;
 LocTypTemp_acc_psy AgSimTrain_acc_psy;                
    /* FIN temporal */
#line 44 "prog.psy"

   /* display */ 
      
              
    /* FIN display */
   /* consult */ 
extern Coef   Buf_AgSimTrain_AgSimBrakes_alpha_psy[]  ;
 
     extern Coef   Buf_AgSimTrain_AgSimEngine_alpha_psy[]  ;
 
     extern Vitesse   Buf_AgSimTrain_AgSimWind_vent_psy[]  ;
 
    /* FIN consult */
#line 53 "prog.psy"


 
void AgSimTrain()
{ long mod_psy;
enum { start_psy,tourne_psy  } body_actif_psy=start_psy;
goto LabDeb_AgSimTrain_start_psy;
/* debut body start */
#line 55 "prog.psy"
LabDeb_AgSimTrain_start_psy:  
   {AgSimTrain_acc_psy=0.0; AgSimTrain_vit_moy_psy=0.0;
     body_actif_psy=tourne_psy ; 
     prog_advance_1_psy( );
   } /* fin body start */
#line 197 "prog.c"
LabFin_AgSimTrain_start_psy:
switch (body_actif_psy)
  {
      
    case tourne_psy : prog_UpBo_2_psy(); goto LabDeb_AgSimTrain_tourne_psy;  
  } /* fin switch */

 
/* debut body tourne */
#line 60 "prog.psy"
LabDeb_AgSimTrain_tourne_psy:  
   {acc1 =  Buf_AgSimTrain_AgSimEngine_alpha_psy[((  (0) )+Ind_AgSimTrain_AgSimEngine_alpha_psy)%Dim_AgSimTrain_AgSimEngine_alpha_psy]      * a2;
    temp =  Buf_AgSimTrain_AgSimTrain_vitesse_psy[((  (0) )+Ind_AgSimTrain_AgSimTrain_vitesse_psy)%Dim_AgSimTrain_AgSimTrain_vitesse_psy]      +  Buf_AgSimTrain_AgSimWind_vent_psy[((  (0) )+Ind_AgSimTrain_AgSimWind_vent_psy)%Dim_AgSimTrain_AgSimWind_vent_psy]     ;
    acc2 = (k0 * temp * temp) + ( Buf_AgSimTrain_AgSimBrakes_alpha_psy[((  (0) )+Ind_AgSimTrain_AgSimBrakes_alpha_psy)%Dim_AgSimTrain_AgSimBrakes_alpha_psy]      * a1 + a0);  
    if( Buf_AgSimTrain_AgSimTrain_vitesse_psy[((  (0) )+Ind_AgSimTrain_AgSimTrain_vitesse_psy)%Dim_AgSimTrain_AgSimTrain_vitesse_psy]      == 0.0) { prog_Upda_3_psy(); acc2=0.0; } else { prog_Upda_4_psy(); }
    AgSimTrain_acc_psy = acc1 - acc2;         
    AgSimTrain_vitesse_psy =  Buf_AgSimTrain_AgSimTrain_vitesse_psy[((  (0) )+Ind_AgSimTrain_AgSimTrain_vitesse_psy)%Dim_AgSimTrain_AgSimTrain_vitesse_psy]      + AgSimTrain_acc_psy * delta_t;
    if (AgSimTrain_vitesse_psy<-1e-3) { prog_Upda_5_psy(); AgSimTrain_vitesse_psy=0.0; } else { prog_Upda_6_psy(); } 
    
    AgSimTrain_vit_moy_psy=(AgSimTrain_vitesse_psy+ Buf_AgSimTrain_AgSimTrain_vitesse_psy[((  (0) )+Ind_AgSimTrain_AgSimTrain_vitesse_psy)%Dim_AgSimTrain_AgSimTrain_vitesse_psy]     )/2;
     prog_advance_2_psy( );
   } /* fin body tourne */
#line 220 "prog.c"
LabFin_AgSimTrain_tourne_psy:
switch (body_actif_psy)
  {
    case tourne_psy : prog_UpBo_3_psy(); goto LabDeb_AgSimTrain_tourne_psy;  
  } /* fin switch */

} /* fin agent */
#endif
#line 72 "prog.psy"


/*=====================================================================================*/
/*-------------------------------  Simu Moteur/Frein ----------------------------------*/
/*     Agent de simulation du moteur electrique ou du frein.                           */
/*=====================================================================================*/

#line 237 "prog.c"
#ifdef AgSimEngine_psy
  unsigned long pileAgent_AgSimEngine_psy[TaillePileAgent_AgSimEngine_psy];
  unsigned long long AgSimEngine_presenttime_psy();
  extern IVTE indVTEx_AgSimEngine_psy[];
  extern IVTC indVTCo_AgSimEngine_psy[];
  /* agent  AgSimEngine (starttime=1) with   HA_Simu  
  */

  /* DEB global  
     */ static Coef alpha_com=0.0; 
    /* FIN global */  
  /* DEB temporal  
    */
#line 84 "prog.psy"

 
 typedef Coef   LocTypTemp_alpha_psy;
 extern LocTypTemp_alpha_psy Buf_AgSimEngine_AgSimEngine_alpha_psy[]  ;
 LocTypTemp_alpha_psy AgSimEngine_alpha_psy; 
     
 
 typedef Coef   LocTypTemp_data_psy;
 extern LocTypTemp_data_psy Buf_AgSimEngine_AgSimEngine_data_psy[]  ;
 LocTypTemp_data_psy AgSimEngine_data_psy; 
    /* FIN temporal */
#line 86 "prog.psy"
 
   /* display */ 
     
        /* FIN display */ 
  /* DEB mesbox  with HA_Controle 
    */
#line 91 "prog.psy"
typedef MiseAJour LocTypBox_Commande_psy ; 
    /* FIN mesbox */ 
   /* receive */ 

/* FIN receive */  
  
void AgSimEngine()
{ long mod_psy;
enum { start_psy,tourne_psy  } body_actif_psy=start_psy;
goto LabDeb_AgSimEngine_start_psy;
/* debut body start */
#line 96 "prog.psy"
LabDeb_AgSimEngine_start_psy:   
    {AgSimEngine_data_psy=0.0;
      body_actif_psy=tourne_psy ;
      prog_advance_3_psy( );
    } /* fin body start */
#line 288 "prog.c"
LabFin_AgSimEngine_start_psy:
switch (body_actif_psy)
  {
      
    case tourne_psy : prog_UpBo_5_psy(); goto LabDeb_AgSimEngine_tourne_psy;  
  } /* fin switch */
 
  
/* debut body tourne */
#line 101 "prog.psy"
LabDeb_AgSimEngine_tourne_psy:   
    {for(;;){ 
        /* firstof */   if( prog_count_1_psy()>=1 ) { prog_when_1_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_1_psy(&Commande); 
       {if( Commande.type== 1   ) { prog_Upda_12_psy(); 
         {AgSimEngine_data_psy+= Commande.valeur; 
          if(AgSimEngine_data_psy>1.0) { prog_Upda_14_psy(); AgSimEngine_data_psy=1.0; } else { prog_Upda_15_psy(); }
         } 
        } else { prog_Upda_13_psy(); if( Commande.type== 2  ) { prog_Upda_16_psy(); 
         {AgSimEngine_data_psy-= Commande.valeur; 
          if(AgSimEngine_data_psy<0.0) { prog_Upda_18_psy(); AgSimEngine_data_psy=0.0; } else { prog_Upda_19_psy(); } 
         } 
        } else { prog_Upda_17_psy(); if( Commande.type== 3  ) { prog_Upda_20_psy(); 
         {AgSimEngine_data_psy = Commande.valeur; 
          if(AgSimEngine_data_psy<0.0) { prog_Upda_22_psy(); AgSimEngine_data_psy=0.0; } else { prog_Upda_23_psy(); }
          if(AgSimEngine_data_psy>1.0 ) { prog_Upda_24_psy(); AgSimEngine_data_psy=1.0; } else { prog_Upda_25_psy(); }
         } } else { prog_Upda_21_psy(); } } }
       }}} else { prog_Upda_11_psy(); 
        /* other */  /*break*/goto sortLab_1_psy; } 
        /* endof */  /* ; */ } sortLab_1_psy:; 
     alpha_com = AgSimEngine_data_psy; 
     AgSimEngine_alpha_psy = ( Buf_AgSimEngine_AgSimEngine_alpha_psy[((  (0) )+Ind_AgSimEngine_AgSimEngine_alpha_psy)%Dim_AgSimEngine_AgSimEngine_alpha_psy]     *  49.0 +alpha_com)/(  49.0 +1.0); 
     if (AgSimEngine_alpha_psy < -1e-3) { prog_Upda_26_psy(); AgSimEngine_alpha_psy= 0.0; } else { prog_Upda_27_psy(); } 
      prog_advance_4_psy( ); 
    } /* fin body tourne */
#line 323 "prog.c"
LabFin_AgSimEngine_tourne_psy:
switch (body_actif_psy)
  {
    case tourne_psy : prog_UpBo_6_psy(); goto LabDeb_AgSimEngine_tourne_psy;  
  } /* fin switch */
 
} /* fin agent */
#endif
#line 125 "prog.psy"
 


#line 336 "prog.c"
#ifdef AgSimBrakes_psy
  unsigned long pileAgent_AgSimBrakes_psy[TaillePileAgent_AgSimBrakes_psy];
  unsigned long long AgSimBrakes_presenttime_psy();
  extern IVTE indVTEx_AgSimBrakes_psy[];
  extern IVTC indVTCo_AgSimBrakes_psy[];
  /* agent  AgSimBrakes (starttime=1) with    HA_Simu  
  */

  /* DEB global  
     */ static Coef alpha_com=0.0; 
    /* FIN global */  
  /* DEB temporal  
    */
#line 133 "prog.psy"

 
 typedef Coef   LocTypTemp_alpha_psy;
 extern LocTypTemp_alpha_psy Buf_AgSimBrakes_AgSimBrakes_alpha_psy[]  ;
 LocTypTemp_alpha_psy AgSimBrakes_alpha_psy; 
     
 
 typedef Coef   LocTypTemp_data_psy;
 extern LocTypTemp_data_psy Buf_AgSimBrakes_AgSimBrakes_data_psy[]  ;
 LocTypTemp_data_psy AgSimBrakes_data_psy; 
    /* FIN temporal */
#line 135 "prog.psy"
 
   /* display */ 
     
        
    /* FIN display */ 
  /* DEB mesbox  with HA_Controle 
    */
#line 141 "prog.psy"
typedef MiseAJour LocTypBox_Commande_psy ; 
    /* FIN mesbox */ 
   /* receive */ 

/* FIN receive */  
  
void AgSimBrakes()
{ long mod_psy;
enum { start_psy,tourne_psy  } body_actif_psy=start_psy;
goto LabDeb_AgSimBrakes_start_psy;
/* debut body start */
#line 146 "prog.psy"
LabDeb_AgSimBrakes_start_psy:   
    {AgSimBrakes_data_psy=0.0; 
      body_actif_psy=tourne_psy ;
      prog_advance_5_psy( );
    } /* fin body start */
#line 388 "prog.c"
LabFin_AgSimBrakes_start_psy:
switch (body_actif_psy)
  {
      
    case tourne_psy : prog_UpBo_8_psy(); goto LabDeb_AgSimBrakes_tourne_psy;  
  } /* fin switch */
 
  
/* debut body tourne */
#line 151 "prog.psy"
LabDeb_AgSimBrakes_tourne_psy:   
    {for(;;){ 
        /* firstof */   if( prog_count_2_psy()>=1 ) { prog_when_2_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_2_psy(&Commande); 
        {if( Commande.type== 1   ) { prog_Upda_33_psy(); 
          {AgSimBrakes_data_psy+=Commande.valeur; 
           if(AgSimBrakes_data_psy>1.0) { prog_Upda_35_psy(); AgSimBrakes_data_psy=1.0; } else { prog_Upda_36_psy(); } 
          } 
         } else { prog_Upda_34_psy(); if( Commande.type== 2   ) { prog_Upda_37_psy(); 
          {AgSimBrakes_data_psy-=Commande.valeur; 
           if(AgSimBrakes_data_psy<0.0) { prog_Upda_39_psy(); AgSimBrakes_data_psy=0.0; } else { prog_Upda_40_psy(); } 
          } 
         } else { prog_Upda_38_psy(); if( Commande.type== 3    ) { prog_Upda_41_psy(); 
          {AgSimBrakes_data_psy =Commande.valeur; 
           if(AgSimBrakes_data_psy<0.0) { prog_Upda_43_psy(); AgSimBrakes_data_psy=0.0; } else { prog_Upda_44_psy(); } 
           if( AgSimBrakes_data_psy>1.0 ) { prog_Upda_45_psy(); AgSimBrakes_data_psy=1.0; } else { prog_Upda_46_psy(); }
          } } else { prog_Upda_42_psy(); } } } 
        }}} else { prog_Upda_32_psy(); 
       /* other */  /*break*/goto sortLab_2_psy; } 
       /* endof */  /* ; */ } sortLab_2_psy:; 
    alpha_com = AgSimBrakes_data_psy; 
    AgSimBrakes_alpha_psy = ( Buf_AgSimBrakes_AgSimBrakes_alpha_psy[((  (0) )+Ind_AgSimBrakes_AgSimBrakes_alpha_psy)%Dim_AgSimBrakes_AgSimBrakes_alpha_psy]     *   9.0 +alpha_com)/(   9.0 +1.0); 
    if (AgSimBrakes_alpha_psy < -1e-3) { prog_Upda_47_psy(); AgSimBrakes_alpha_psy= 0.0; } else { prog_Upda_48_psy(); } 
     prog_advance_6_psy( ); 
    } /* fin body tourne */
#line 423 "prog.c"
LabFin_AgSimBrakes_tourne_psy:
switch (body_actif_psy)
  {
    case tourne_psy : prog_UpBo_9_psy(); goto LabDeb_AgSimBrakes_tourne_psy;  
  } /* fin switch */
 
} /* fin agent */
#endif
#line 175 "prog.psy"
 

/*=====================================================================================*/
/*-------------------------------  AgSimWind  ------------------------------------------*/
/*     Agent de simulation du vent.                                                    */
/*=====================================================================================*/

#line 440 "prog.c"
#ifdef AgSimWind_psy
  unsigned long pileAgent_AgSimWind_psy[TaillePileAgent_AgSimWind_psy];
  unsigned long long AgSimWind_presenttime_psy();
  extern IVTE indVTEx_AgSimWind_psy[];
  extern IVTC indVTCo_AgSimWind_psy[];
  /* agent AgSimWind(starttime= 1) with HA_Simu
  */

  /* DEB global 
     */ static const Coef k=49.0;
    /* FIN global */ 
  /* DEB temporal 
    */
#line 187 "prog.psy"

 
 typedef Vitesse   LocTypTemp_vent_psy;
 extern LocTypTemp_vent_psy Buf_AgSimWind_AgSimWind_vent_psy[]  ;
 LocTypTemp_vent_psy AgSimWind_vent_psy/*={0.0}*/ ;
    /* FIN temporal */
#line 188 "prog.psy"

   /* display */ 
   
    /* FIN display */
  /* consult */ 
extern Vitesse   Buf_AgSimWind_AgSimWindBlast_vent_psy[]  ;
 
   /* FIN consult */
#line 194 "prog.psy"
 

 
void AgSimWind()
{ long mod_psy;
enum { start_psy  } body_actif_psy=start_psy;
goto LabDeb_AgSimWind_start_psy;
/* debut body start */
#line 196 "prog.psy"
LabDeb_AgSimWind_start_psy:  
   {AgSimWind_vent_psy=(( Buf_AgSimWind_AgSimWind_vent_psy[((  (0) )+Ind_AgSimWind_AgSimWind_vent_psy)%Dim_AgSimWind_AgSimWind_vent_psy]     *k)+ Buf_AgSimWind_AgSimWindBlast_vent_psy[((  (0) )+Ind_AgSimWind_AgSimWindBlast_vent_psy)%Dim_AgSimWind_AgSimWindBlast_vent_psy]     )/(1.0+k);
    if (AgSimWind_vent_psy < -1e-3) { prog_Upda_50_psy(); AgSimWind_vent_psy= 0.0; } else { prog_Upda_51_psy(); }
     prog_advance_7_psy( ); 
   } /* fin body start */
#line 485 "prog.c"
LabFin_AgSimWind_start_psy:
switch (body_actif_psy)
  {
    case start_psy : prog_UpBo_10_psy(); goto LabDeb_AgSimWind_start_psy;  
  } /* fin switch */

} /* fin agent */
#endif
#line 201 "prog.psy"


/*=====================================================================================*/
/*-------------------------------  AgSimWindBlast  ----------------------------------------*/
/*     Agent de simulation des rafales.                                                */
/*=====================================================================================*/

#line 502 "prog.c"
#ifdef AgSimWindBlast_psy
  unsigned long pileAgent_AgSimWindBlast_psy[TaillePileAgent_AgSimWindBlast_psy];
  unsigned long long AgSimWindBlast_presenttime_psy();
  extern IVTE indVTEx_AgSimWindBlast_psy[];
  extern IVTC indVTCo_AgSimWindBlast_psy[];
  /* agent AgSimWindBlast(starttime= 1) with HA_Rafale
  */

  /* DEB global  
     */ static long  alea ;
     static long  toto ;
    /* FIN global */      
  /* DEB temporal  
    */
#line 214 "prog.psy"

 
 typedef Vitesse   LocTypTemp_vent_psy;
 extern LocTypTemp_vent_psy Buf_AgSimWindBlast_AgSimWindBlast_vent_psy[]  ;
 LocTypTemp_vent_psy AgSimWindBlast_vent_psy;

 
 typedef int   LocTypTemp_status_psy;
 extern LocTypTemp_status_psy Buf_AgSimWindBlast_AgSimWindBlast_status_psy[]  ;
 LocTypTemp_status_psy AgSimWindBlast_status_psy;
    /* FIN temporal */
#line 216 "prog.psy"

   /* display */ 
  
       
    /* FIN display */    
  /* DEB mesbox 
    */
#line 222 "prog.psy"
typedef MiseAJour LocTypBox_Commande_psy; // il y a 50 pas de 100ms dans [alea[max]=5] 5 secondes
    /* FIN mesbox */ 
   /* receive */ 

/* FIN receive */ 
  
void AgSimWindBlast()
{ long mod_psy;
enum { start_psy,NUL_psy,FAIBLE_psy,MOYEN_psy,FORT_psy  } body_actif_psy=start_psy;
goto LabDeb_AgSimWindBlast_start_psy;
/* debut body start */
#line 227 "prog.psy"
LabDeb_AgSimWindBlast_start_psy:   
    {AgSimWindBlast_vent_psy=0.0; 
      body_actif_psy=FAIBLE_psy ;
    } /* fin body start */
#line 554 "prog.c"
LabFin_AgSimWindBlast_start_psy:
switch (body_actif_psy)
  {
      
    case FAIBLE_psy : prog_UpBo_12_psy(); goto LabDeb_AgSimWindBlast_FAIBLE_psy;  
  } /* fin switch */


  
/* debut body NUL */
#line 232 "prog.psy"
LabDeb_AgSimWindBlast_NUL_psy:  
    {AgSimWindBlast_status_psy= 0 ; 
     for(;;){
        /* firstof */ 
          if( prog_count_3_psy()>=1 ) { prog_when_3_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_3_psy(&Commande); {if(Commande.type== 1 ) { prog_Upda_57_psy();  body_actif_psy=FAIBLE_psy ; } else { prog_Upda_58_psy(); }}}} else { prog_Upda_56_psy();
          /* other */  /*break*/goto sortLab_3_psy; }
        /* endof */  /* ; */ } sortLab_3_psy:;
      prog_advance_8_psy( );
    } /* fin body NUL */
#line 575 "prog.c"
LabFin_AgSimWindBlast_NUL_psy:
switch (body_actif_psy)
  {
    case NUL_psy : prog_UpBo_13_psy(); goto LabDeb_AgSimWindBlast_NUL_psy;  
    case FAIBLE_psy : prog_UpBo_14_psy(); goto LabDeb_AgSimWindBlast_FAIBLE_psy;  
  } /* fin switch */



/* debut body FAIBLE */
#line 242 "prog.psy"
LabDeb_AgSimWindBlast_FAIBLE_psy:  
  {AgSimWindBlast_status_psy= 1 ;
   if(prog_count_4_psy()==0) { prog_Upda_61_psy();
     {AgSimWindBlast_vent_psy = rand_float(0.0, 5.0);}
    } else { prog_Upda_62_psy();  
     for(;;){
        /* firstof */ 
          if( prog_count_5_psy()>=1 ) { prog_when_4_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_4_psy(&Commande); {
           if( Commande.type== 2  ) { prog_Upda_65_psy(); { body_actif_psy=NUL_psy ;   AgSimWindBlast_vent_psy=0.0;} } else { prog_Upda_66_psy(); }
           if( Commande.type== 1   ) { prog_Upda_67_psy(); { body_actif_psy=MOYEN_psy ; AgSimWindBlast_vent_psy=5.0;} } else { prog_Upda_68_psy(); }
         }}} else { prog_Upda_64_psy();
          /* other */  /*break*/goto sortLab_4_psy; }
        /* endof */  /* ; */ } sortLab_4_psy:; }
    
   alea = rand_long(3, 5);
    prog_advance_9_psy(alea);
  } /* fin body FAIBLE */
#line 604 "prog.c"
LabFin_AgSimWindBlast_FAIBLE_psy:
switch (body_actif_psy)
  {
    case NUL_psy : prog_UpBo_15_psy(); goto LabDeb_AgSimWindBlast_NUL_psy;  
    case FAIBLE_psy : prog_UpBo_16_psy(); goto LabDeb_AgSimWindBlast_FAIBLE_psy;  
    case MOYEN_psy : prog_UpBo_17_psy(); goto LabDeb_AgSimWindBlast_MOYEN_psy;  
  } /* fin switch */



/* debut body MOYEN */
#line 260 "prog.psy"
LabDeb_AgSimWindBlast_MOYEN_psy:  
  {AgSimWindBlast_status_psy= 2 ;
   if(prog_count_6_psy()==0) { prog_Upda_72_psy();
     {AgSimWindBlast_vent_psy = rand_float(2.0, 12.0);}
    } else { prog_Upda_73_psy();  
     for(;;){
        /* firstof */ 
          if( prog_count_7_psy()>=1 ) { prog_when_5_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_5_psy(&Commande); {
           if( Commande.type== 2  ) { prog_Upda_76_psy(); { body_actif_psy=FAIBLE_psy ; AgSimWindBlast_vent_psy=2.0;} } else { prog_Upda_77_psy(); }
           if( Commande.type== 1   ) { prog_Upda_78_psy(); { body_actif_psy=FORT_psy ;   AgSimWindBlast_vent_psy=12.0;} } else { prog_Upda_79_psy(); }
         }}} else { prog_Upda_75_psy();
          /* other */  /*break*/goto sortLab_5_psy; }
        /* endof */  /* ; */ } sortLab_5_psy:; }

   alea = rand_long(2, 5);
    prog_advance_10_psy(alea);
  } /* fin body MOYEN */
#line 634 "prog.c"
LabFin_AgSimWindBlast_MOYEN_psy:
switch (body_actif_psy)
  {
    case FAIBLE_psy : prog_UpBo_18_psy(); goto LabDeb_AgSimWindBlast_FAIBLE_psy;  
    case MOYEN_psy : prog_UpBo_19_psy(); goto LabDeb_AgSimWindBlast_MOYEN_psy;  
    case FORT_psy : prog_UpBo_20_psy(); goto LabDeb_AgSimWindBlast_FORT_psy;  
  } /* fin switch */



/* debut body FORT */
#line 278 "prog.psy"
LabDeb_AgSimWindBlast_FORT_psy:  
  {AgSimWindBlast_status_psy= 3 ;
   if(prog_count_8_psy()==0) { prog_Upda_83_psy();
     {AgSimWindBlast_vent_psy = rand_float(5.0, 25.0);}
    } else { prog_Upda_84_psy();  
     for(;;){
        /* firstof */ 
          if( prog_count_9_psy()>=1 ) { prog_when_6_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_6_psy(&Commande); {
           if( Commande.type== 2  ) { prog_Upda_87_psy(); { body_actif_psy=MOYEN_psy ; AgSimWindBlast_vent_psy=5.0;} } else { prog_Upda_88_psy(); }
           if( Commande.type== 1   ) { prog_Upda_89_psy(); { body_actif_psy=FORT_psy ;  AgSimWindBlast_vent_psy=25.0;} } else { prog_Upda_90_psy(); }
         }}} else { prog_Upda_86_psy();
          /* other */  /*break*/goto sortLab_6_psy; }
        /* endof */  /* ; */ } sortLab_6_psy:; }

   alea = rand_long(1, 4);
    prog_advance_11_psy(alea);
  } /* fin body FORT */
#line 664 "prog.c"
LabFin_AgSimWindBlast_FORT_psy:
switch (body_actif_psy)
  {
    case MOYEN_psy : prog_UpBo_21_psy(); goto LabDeb_AgSimWindBlast_MOYEN_psy;  
    case FORT_psy : prog_UpBo_22_psy(); goto LabDeb_AgSimWindBlast_FORT_psy;  
  } /* fin switch */

} /* fin agent */
#endif
#line 295 "prog.psy"


/*=====================================================================================*/
/*--------------------------------  AgControl  -----------------------------------------*/
/*     Agent de controle-commande du train.                                            */
/*=====================================================================================*/

#line 682 "prog.c"
#ifdef AgControl_psy
  unsigned long pileAgent_AgControl_psy[TaillePileAgent_AgControl_psy];
  unsigned long long AgControl_presenttime_psy();
  extern IVTE indVTEx_AgControl_psy[];
  extern IVTC indVTCo_AgControl_psy[];
  /* agent AgControl(starttime=1) with HA_Controle
  */

  /* DEB global  
     */ static Vitesse delta_v=0.0;                /* Ecart vitesse cible - vitesse du train */
     static MiseAJour CmdMoteur, CmdFrein;                       /* Messages en emission */
     static Coef PasFrein=0.08;
     static Coef PasMin=0.1;
     static Coef PasMoteur=0.25;
     static Vitesse seuil=2.5;
     static int FreinFort= 0 ;
    /* FIN global */ 
  /* DEB temporal 
    */
#line 313 "prog.psy"

 
 typedef int   LocTypTemp_status_psy;
 extern LocTypTemp_status_psy Buf_AgControl_AgControl_status_psy[]  ;
 LocTypTemp_status_psy AgControl_status_psy;
     
 
 typedef Vitesse   LocTypTemp_vit_cible_psy;
 extern LocTypTemp_vit_cible_psy Buf_AgControl_AgControl_vit_cible_psy[]  ;
 LocTypTemp_vit_cible_psy AgControl_vit_cible_psy;       
    /* FIN temporal */
#line 315 "prog.psy"

   /* display */ 
   
    /* FIN display */
   /* consult */ 
extern Coef   Buf_AgControl_AgSimBrakes_alpha_psy[]  ;
 
     extern Coef   Buf_AgControl_AgSimEngine_alpha_psy[]  ;
 
     extern Vitesse   Buf_AgControl_AgSimTrain_vit_moy_psy[]  ;
/*same*/  extern Acceleration   Buf_AgControl_AgSimTrain_acc_psy[]  ;
 
    /* FIN consult */
#line 323 "prog.psy"

  /* DEB mesbox 
    */
#line 325 "prog.psy"
typedef MiseAJour LocTypBox_Commande_psy; 
     typedef TypeVit LocTypBox_VitesseCible_psy;
    /* FIN mesbox */ 
   /* receive */ 


/* FIN receive */ 
  
void AgControl()
{ long mod_psy;
enum { start_psy,COMMANDE_psy,ACTIF_psy  } body_actif_psy=start_psy;
goto LabDeb_AgControl_start_psy;
/* debut body start */
#line 332 "prog.psy"
LabDeb_AgControl_start_psy:  
    {AgControl_status_psy= 2 ; 
     AgControl_vit_cible_psy=50.0; 
      body_actif_psy=COMMANDE_psy ;
    } /* fin body start */
#line 752 "prog.c"
LabFin_AgControl_start_psy:
switch (body_actif_psy)
  {
      
    case COMMANDE_psy : prog_UpBo_24_psy(); goto LabDeb_AgControl_COMMANDE_psy;  
  } /* fin switch */


  
/* debut body COMMANDE */
#line 338 "prog.psy"
LabDeb_AgControl_COMMANDE_psy:  
    { prog_advance_12_psy ( );
     { long maxBcl_psy=1L; for(;(1) && maxBcl_psy--;){
        /* firstof */ 
          if( prog_count_10_psy()>=1 ) { prog_when_7_psy(); { static LocTypBox_Commande_psy Commande; prog_extract_7_psy(&Commande);
           {switch (Commande.type){
             {
               case 'a' : prog_Upda_97_psy();   
               AgControl_status_psy=(AgControl_status_psy == 1 ) ? 2  : 1 ;
               break;
               case 'w' : prog_Upda_98_psy();   
               AgControl_status_psy= 1 ;
               CmdMoteur.valeur= (0.05); ;
               CmdMoteur.type = 2 ;
               prog_send_1_psy( &CmdMoteur) ;
               CmdFrein.type= 3 ;
               CmdFrein.valeur=0.0;
               prog_send_2_psy( &CmdFrein) ;
               break;
               case 'x' : prog_Upda_99_psy();   
               AgControl_status_psy= 1 ;
               CmdMoteur.valeur= (0.05); ;
               CmdMoteur.type = 1 ;
               prog_send_3_psy( &CmdMoteur) ;
               CmdFrein.type= 3 ;
               CmdFrein.valeur=0.0;
               prog_send_4_psy( &CmdFrein) ;
               break;
               case 'n' : prog_Upda_100_psy();   
               AgControl_status_psy= 1 ;
               CmdFrein.valeur= (0.05); ;
               CmdFrein.type = 1 ;
               prog_send_5_psy( &CmdFrein) ;
               CmdMoteur.type= 3 ;
               CmdMoteur.valeur=0.0;
               prog_send_6_psy( &CmdMoteur) ;
               break;
               case 'b' : prog_Upda_101_psy();   
               AgControl_status_psy= 1 ;
               CmdFrein.valeur= (0.05); ;
               CmdFrein.type = 2 ;
               prog_send_7_psy( &CmdFrein) ;
               CmdMoteur.type= 3 ;
               CmdMoteur.valeur=0.0;
               prog_send_8_psy( &CmdMoteur) ;
               break;
               default : prog_Upda_102_psy();   
               break;
             }}
           }}} else { prog_Upda_96_psy();
          if( prog_count_11_psy()>=1 ) { prog_when_8_psy(); { static LocTypBox_VitesseCible_psy VitesseCible; prog_extract_8_psy(&VitesseCible);
           /* AgControl de la validite de la vitesse */
           {if(VitesseCible>0 && VitesseCible<=500) { prog_Upda_104_psy();
            AgControl_vit_cible_psy = (float)VitesseCible/3.6; } else { prog_Upda_105_psy(); }
           }}} else { prog_Upda_103_psy();
         /* other */ 
          /*break*/goto sortLab_7_psy; }}
       /* endof */  /* ; */ contLab_7_psy:if(maxBcl_psy) prog_Upda_95_psy();} prog_Upda_106_psy(); sortLab_7_psy:;}
      if (AgControl_status_psy== 2 ) { prog_Upda_107_psy();
         body_actif_psy=ACTIF_psy ; } else { prog_Upda_108_psy(); }
    } /* fin body COMMANDE */
#line 825 "prog.c"
LabFin_AgControl_COMMANDE_psy:
switch (body_actif_psy)
  {
    case COMMANDE_psy : prog_UpBo_25_psy(); goto LabDeb_AgControl_COMMANDE_psy;  
    case ACTIF_psy : prog_UpBo_26_psy(); goto LabDeb_AgControl_ACTIF_psy;  
  } /* fin switch */


  
/* debut body ACTIF */
#line 400 "prog.psy"
LabDeb_AgControl_ACTIF_psy:  
    {
      if(AgControl_vit_cible_psy>0.0) { prog_Upda_111_psy();
        {delta_v = AgControl_vit_cible_psy -  Buf_AgControl_AgSimTrain_vit_moy_psy[((  (0) )+Ind_AgControl_AgSimTrain_vit_moy_psy)%Dim_AgControl_AgSimTrain_vit_moy_psy]     ;     
         if(delta_v > seuil) { prog_Upda_113_psy();
           {if ( Buf_AgControl_AgSimTrain_acc_psy[((  (0) )+Ind_AgControl_AgSimTrain_acc_psy)%Dim_AgControl_AgSimTrain_acc_psy]      > 1.0) { prog_Upda_115_psy();
              CmdMoteur.valeur =  Buf_AgControl_AgSimEngine_alpha_psy[((  (0) )+Ind_AgControl_AgSimEngine_alpha_psy)%Dim_AgControl_AgSimEngine_alpha_psy]      ;
             } else { prog_Upda_116_psy();
              CmdMoteur.valeur =  Buf_AgControl_AgSimEngine_alpha_psy[((  (0) )+Ind_AgControl_AgSimEngine_alpha_psy)%Dim_AgControl_AgSimEngine_alpha_psy]     +PasMoteur; }
            CmdMoteur.type= 3 ;
            if (CmdMoteur.valeur > 1.0) { prog_Upda_117_psy(); CmdMoteur.valeur = 1.0; } else { prog_Upda_118_psy(); }
            prog_send_9_psy( &CmdMoteur);
            FreinFort= 0 ;
            CmdFrein.valeur=0.0;
            CmdFrein.type= 3 ;
            prog_send_10_psy( &CmdFrein);
           }
          } else { prog_Upda_114_psy(); if(delta_v < -seuil) { prog_Upda_119_psy();
           {CmdMoteur.valeur=0.0;
            CmdMoteur.type= 3 ;
            prog_send_11_psy( &CmdMoteur);
            FreinFort= (0xAAAAAAAAul) ;
            if ( Buf_AgControl_AgSimTrain_acc_psy[((  (0) )+Ind_AgControl_AgSimTrain_acc_psy)%Dim_AgControl_AgSimTrain_acc_psy]      < -1.0) { prog_Upda_121_psy();
              CmdFrein.valeur =  Buf_AgControl_AgSimBrakes_alpha_psy[((  (0) )+Ind_AgControl_AgSimBrakes_alpha_psy)%Dim_AgControl_AgSimBrakes_alpha_psy]      ;
             } else { prog_Upda_122_psy();
              CmdFrein.valeur =  Buf_AgControl_AgSimBrakes_alpha_psy[((  (0) )+Ind_AgControl_AgSimBrakes_alpha_psy)%Dim_AgControl_AgSimBrakes_alpha_psy]     +PasFrein; }
            CmdFrein.type= 3 ;
            if (CmdFrein.valeur > 1.0) { prog_Upda_123_psy(); CmdFrein.valeur = 1.0; } else { prog_Upda_124_psy(); }
            prog_send_12_psy( &CmdFrein); 
           }
          } else { prog_Upda_120_psy(); if (delta_v < (-AgControl_vit_cible_psy/100.0) && FreinFort== (0xAAAAAAAAul) ) { prog_Upda_125_psy(); // 100.0
           {if(( Buf_AgControl_AgSimBrakes_alpha_psy[((  (0) )+Ind_AgControl_AgSimBrakes_alpha_psy)%Dim_AgControl_AgSimBrakes_alpha_psy]     +(delta_v/seuil)) > PasFrein) { prog_Upda_127_psy();
              CmdFrein.valeur= Buf_AgControl_AgSimBrakes_alpha_psy[((  (0) )+Ind_AgControl_AgSimBrakes_alpha_psy)%Dim_AgControl_AgSimBrakes_alpha_psy]     -PasFrein;
             } else { prog_Upda_128_psy();   
              CmdFrein.valeur=(-delta_v/seuil); }
            CmdFrein.type= 3 ;
            prog_send_13_psy( &CmdFrein);        
           }
          } else { prog_Upda_126_psy(); if(CmdFrein.valeur == 0.0) { prog_Upda_129_psy(); // ou FreinFort== 0 
           {Acceleration acc=( Buf_AgControl_AgSimTrain_vit_moy_psy[((  (0) )+Ind_AgControl_AgSimTrain_vit_moy_psy)%Dim_AgControl_AgSimTrain_vit_moy_psy]      -  Buf_AgControl_AgSimTrain_vit_moy_psy[((  (9) )+Ind_AgControl_AgSimTrain_vit_moy_psy)%Dim_AgControl_AgSimTrain_vit_moy_psy]     )/0.1;
            Coef delta_alpha=(delta_v/seuil)-(acc/0.76);
                
            if(delta_alpha > PasMin) { prog_Upda_131_psy(); delta_alpha = PasMin; } else { prog_Upda_132_psy(); }
            if(delta_alpha < -PasMin) { prog_Upda_133_psy(); delta_alpha = -PasMin; } else { prog_Upda_134_psy(); }
            CmdMoteur.type= 3 ;
            CmdMoteur.valeur= Buf_AgControl_AgSimEngine_alpha_psy[((  (0) )+Ind_AgControl_AgSimEngine_alpha_psy)%Dim_AgControl_AgSimEngine_alpha_psy]      + delta_alpha; 
            prog_send_14_psy( &CmdMoteur);
           }
          } else { prog_Upda_130_psy();
           {FreinFort= 0 ;
            CmdFrein.valeur=0.0;
            CmdFrein.type= 3 ;
            prog_send_15_psy( &CmdFrein); 
           } } } } }
        } } else { prog_Upda_112_psy(); }
       body_actif_psy=COMMANDE_psy ;
    } /* fin body ACTIF */
#line 894 "prog.c"
LabFin_AgControl_ACTIF_psy:
switch (body_actif_psy)
  {
    case COMMANDE_psy : prog_UpBo_27_psy(); goto LabDeb_AgControl_COMMANDE_psy;  
      
  } /* fin switch */

} /* fin agent */
#endif
#line 457 "prog.psy"


/* FIN gnration fichier */

